//Brent Cowan - Jan. 3 / 2010

#include "EngineCore.h"
#include "Camera2D.h"

Core* Camera2D::G = NULL;

Camera2D::Camera2D(Core* G)
{
	this->G     = G;
	zoom        = 1.0f;
	rotation    = 0.0f;
	vibration   = 0.0f;
	wobble      = 0.0f;
	wobbleTimer = 9.0f;
}

void Camera2D::Activate()
{
	//Add Vibration
	Vector2D tempPos = tempPos.AngleToVector(float(rand()%360)) * (vibration / zoom);
	tempPos += position;

	wobbleTimer += G->Timer.GetElapsedTime();
	if(wobbleTimer>0.05f)
	{
		wobbleVector = wobbleVector.AngleToVector(float(rand()%360)) * (wobble / zoom);
		wobbleTimer = 0.0f;
	}
	wobbleSmooth = Smooth(wobbleSmooth, wobbleVector, 2.0f, G->Timer.GetElapsedTime());
	//float tempf = 2.0f/G->getElapsedTime();
	//wobbleSmooth = (wobbleSmooth*tempf+wobbleVector)/(tempf+1.0f);

	tempPos += wobbleSmooth;

	glTranslatef(offset.x, offset.y, 0.0f);
	glScalef(zoom, zoom, 1.0f);
	glRotatef(-rotation, 0.0f, 0.0f, 1.0f);
	glTranslatef(-tempPos.x, -tempPos.y, 0.0f);	
}

void Camera2D::Deactivate()
{
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	glTranslatef(0.0, 0.0, -1.0);
}

Vector2D Camera2D::GetPosition() {return position;}
Vector2D Camera2D::GetOffset()   {return offset;}
float    Camera2D::GetRotation() {return rotation;}
float    Camera2D::GetZoom()     {return zoom;}
float    Camera2D::GetVibration(){return vibration;}
float    Camera2D::GetWobble()   {return wobble/10.0f;}

void     Camera2D::SetPosition(Vector2D position) {this->position  = position;}
void     Camera2D::SetOffset(Vector2D offset)     {this->offset    = offset;}
void     Camera2D::SetRotation(float rotation)    {this->rotation  = rotation;}
void     Camera2D::SetZoom(float zoom)			  {this->zoom      = zoom;}
void     Camera2D::SetVibration(float vibration)  {this->vibration = vibration;}
void     Camera2D::SetWobble(float wobble)        {this->wobble    = wobble*10.0f;}

Vector2D Camera2D::ScreenSpaceToCamera(Vector2D position)
{
	static Vector2D out;
	out = position;
	out = out-offset;
	out = out/zoom;
	out.Rotate(rotation);
	out = out+this->position;

	return out;
}