//Brent Cowan    100233480

#include "EngineCore.h"
#include "Camera3D.h"

Core* Camera3D::G = NULL;

Camera3D::Camera3D(Core* G)
{
	this->G = G;
	rotY=0.0f; rotX=90.0f;  //set direction to 0
	position.y = 40; position.x = 0; position.z = 0; //default position
	offset = 0.1f; focus = 0.2f; //Offset and Focus could have been made constant but
								   //I might want to change them to create effects


	RTD = 180.0f / 3.14159f;
}

void Camera3D::Activate()
{
	//Rotate around Y axis
	if (rotY > 360.0)rotY -= 360.0;
	else if (rotY < 0.0)rotY += 360.0;

	//If in Red/Blue 3D mode, calculate the offset for eyes
	/*if(E.redBlue3D)
	{
		if(E.IsRed)
			{focusDir =  focus; offsetAmount =  offset;}
		else
			{focusDir = -focus; offsetAmount = -offset;}
	}
	else
		{focusDir = 0.0f; offsetAmount = 0.0f;}*/
	focusDir = 0.0f; offsetAmount = 0.0f;

	//Convert angle to vector
	up.polarCoord(rotY, rotX);       vector = up;
	up.polarCoord(rotY+90.0f, 0.0f); strafe = up;
	up = up.Cross(vector);
	//up     = M.polarCoord(rotX+90.0f, rotY);

	//Rotate the camera
	glRotatef(rotX, 1.0f, 0.0f, 0.0f);
	glRotatef(rotY+focusDir, 0.0f, 1.0f, 0.0f);
	
	glTranslatef((position.x+(vector.z*offsetAmount))*(-1), 
				 (position.y)*(-1), 
				 (position.z+(vector.x*(-offsetAmount)))*(-1));
	
	G->Renderer.frustum.Step();//set up the frustum culling
}


void Camera3D::LookAt(Vector3D target)
{
	rotY = 180.0f-(atan2(target.x - position.x, target.z - position.z)*RTD); 
	Vector3D tempV = target-position;
	tempV.y = 0.0f;
	rotX = (atan2(tempV.GetLength(), target.y - position.y)*RTD)-90.0f; 
}
