
#include "stdafx.h"
#include "GLFW/IncludesGLFW.h"
#include "Extensions.h"

DECLDIR PFNGLCREATEPROGRAMOBJECTARBPROC   ext::glCreateProgramObjectARB  = NULL;
DECLDIR PFNGLCREATESHADEROBJECTARBPROC    ext::glCreateShaderObjectARB   = NULL;
DECLDIR PFNGLLINKPROGRAMARBPROC           ext::glLinkProgramARB          = NULL;
DECLDIR PFNGLCOMPILESHADERARBPROC         ext::glCompileShaderARB        = NULL;
DECLDIR PFNGLGETINFOLOGARBPROC            ext::glGetInfoLogARB           = NULL;
DECLDIR PFNGLDELETEOBJECTARBPROC          ext::glDeleteObjectARB         = NULL;
DECLDIR PFNGLUSEPROGRAMOBJECTARBPROC      ext::glUseProgramObjectARB     = NULL;
DECLDIR PFNGLSHADERSOURCEARBPROC          ext::glShaderSourceARB         = NULL;
DECLDIR PFNGLATTACHOBJECTARBPROC          ext::glAttachObjectARB         = NULL;
	// I added this one:
DECLDIR PFNGLDETACHOBJECTARBPROC          ext::glDetachObjectARB         = NULL;
DECLDIR PFNGLGETOBJECTPARAMETERIVARBPROC  ext::glGetObjectParameterivARB = NULL;
DECLDIR PFNGLGETUNIFORMLOCATIONARBPROC    ext::glGetUniformLocationARB   = NULL;
DECLDIR PFNGLGETATTRIBLOCATIONARBPROC     ext::glGetAttribLocationARB    = NULL;
DECLDIR PFNGLUNIFORM4FARBPROC             ext::glUniform4fARB            = NULL;
DECLDIR PFNGLUNIFORM1FARBPROC             ext::glUniform1fARB            = NULL;
DECLDIR PFNGLUNIFORM1IARBPROC             ext::glUniform1iARB            = NULL;
//DECLDIR PFNGLVERTEXATTRIB3SVARBPROC       ext::glVertexAttrib3svARB      = NULL;
DECLDIR PFNGLENABLEVERTEXATTRIBARRAYARBPROC ext::glEnableVertexAttribArrayARB = NULL;
DECLDIR PFNGLVERTEXATTRIBPOINTERARBPROC     ext::glVertexAttribPointerARB = NULL;


	// MultiTexturing
DECLDIR PFNGLMULTITEXCOORD2FARBPROC       ext::glMultiTexCoord2fARB      = NULL;
DECLDIR PFNGLMULTITEXCOORD3FARBPROC       ext::glMultiTexCoord3fARB      = NULL;
DECLDIR PFNGLACTIVETEXTUREARBPROC         ext::glActiveTextureARB        = NULL;

	// Secondary Color
DECLDIR PFNGLSECONDARYCOLOR3FEXTPROC      ext::glSecondaryColor3fEXT     = NULL;
DECLDIR PFNGLSECONDARYCOLORPOINTEREXTPROC ext::glSecondaryColorPointerEXT= NULL;

	// Blending
DECLDIR PFNGLBLENDEQUATIONEXTPROC         ext::glBlendEquationEXT        = NULL;
	//static PFNGLFUNCSUBTRACTEXT         ext::glFuncSubtractEXT         = NULL;

DECLDIR PFNWGLSWAPINTERVALEXTPROC         ext::wglSwapIntervalEXT        = NULL;

	// Frame Buffer Objects
DECLDIR PFNGLGENFRAMEBUFFERSEXTPROC         ext::glGenFramebuffersEXT        = NULL;
DECLDIR PFNGLBINDFRAMEBUFFEREXTPROC         ext::glBindFramebufferEXT        = NULL;
DECLDIR PFNGLGENRENDERBUFFERSEXTPROC        ext::glGenRenderbuffersEXT       = NULL;
DECLDIR PFNGLBINDRENDERBUFFEREXTPROC        ext::glBindRenderbufferEXT       = NULL;
DECLDIR PFNGLRENDERBUFFERSTORAGEEXTPROC     ext::glRenderbufferStorageEXT    = NULL;
DECLDIR PFNGLFRAMEBUFFERRENDERBUFFEREXTPROC ext::glFramebufferRenderbufferEXT= NULL;
DECLDIR PFNGLFRAMEBUFFERTEXTURE2DEXTPROC    ext::glFramebufferTexture2DEXT   = NULL;
DECLDIR PFNGLCHECKFRAMEBUFFERSTATUSEXTPROC  ext::glCheckFramebufferStatusEXT = NULL;
DECLDIR PFNGLDELETEFRAMEBUFFERSEXTPROC      ext::glDeleteFramebuffersEXT     = NULL;
DECLDIR PFNGLDELETERENDERBUFFERSEXTPROC     ext::glDeleteRenderbuffersEXT    = NULL;
DECLDIR PFNGLDRAWBUFFERSPROC                ext::glDrawBuffers               = NULL;

bool DECLDIR InitExtensions()
{
	// GLSlang Shaders
	char *extensions = (char*)glGetString(GL_EXTENSIONS);

	// Check for the neccessary extensions.
	if(strstr(extensions, "GL_ARB_shading_language_100") == NULL)
	  return false;

	if(strstr(extensions, "GL_ARB_shader_objects") == NULL)
	  return false;

	ext::glCreateProgramObjectARB = (PFNGLCREATEPROGRAMOBJECTARBPROC)wglGetProcAddress("glCreateProgramObjectARB");
	ext::glCreateShaderObjectARB = (PFNGLCREATESHADEROBJECTARBPROC)wglGetProcAddress("glCreateShaderObjectARB");
	ext::glCompileShaderARB = (PFNGLCOMPILESHADERARBPROC)wglGetProcAddress("glCompileShaderARB");
	ext::glLinkProgramARB = (PFNGLLINKPROGRAMARBPROC)wglGetProcAddress("glLinkProgramARB");
	ext::glGetInfoLogARB = (PFNGLGETINFOLOGARBPROC)wglGetProcAddress("glGetInfoLogARB");
	ext::glDeleteObjectARB  = (PFNGLDELETEOBJECTARBPROC)wglGetProcAddress("glDeleteObjectARB");
	ext::glUseProgramObjectARB = (PFNGLUSEPROGRAMOBJECTARBPROC)wglGetProcAddress("glUseProgramObjectARB");
	ext::glShaderSourceARB = (PFNGLSHADERSOURCEARBPROC)wglGetProcAddress("glShaderSourceARB");
	ext::glAttachObjectARB = (PFNGLATTACHOBJECTARBPROC)wglGetProcAddress("glAttachObjectARB");
	// I added this one
	ext::glDetachObjectARB = (PFNGLDETACHOBJECTARBPROC)wglGetProcAddress("glDetachObjectARB");
	ext::glGetObjectParameterivARB = (PFNGLGETOBJECTPARAMETERIVARBPROC)wglGetProcAddress("glGetObjectParameterivARB");
	ext::glGetUniformLocationARB = (PFNGLGETUNIFORMLOCATIONARBPROC)wglGetProcAddress("glGetUniformLocationARB");
	ext::glGetAttribLocationARB = (PFNGLGETUNIFORMLOCATIONARBPROC)wglGetProcAddress("glGetAttribLocationARB");
	ext::glUniform4fARB = (PFNGLUNIFORM4FARBPROC)wglGetProcAddress("glUniform4fARB");
	ext::glUniform1fARB = (PFNGLUNIFORM1FARBPROC)wglGetProcAddress("glUniform1fARB");
	ext::glUniform1iARB = (PFNGLUNIFORM1IARBPROC)wglGetProcAddress("glUniform1iARB");
	//ext::glVertexAttrib3svARB = (PFNGLVERTEXATTRIB3SVARBPROC)wglGetProcAddress("glVertexAttrib3svARB");
	ext::glEnableVertexAttribArrayARB = (PFNGLENABLEVERTEXATTRIBARRAYARBPROC)wglGetProcAddress("glEnableVertexAttribArrayARB");
	ext::glVertexAttribPointerARB = (PFNGLVERTEXATTRIBPOINTERARBPROC)wglGetProcAddress("glVertexAttribPointerARB");


	if(!ext::glCreateProgramObjectARB || !ext::glCreateShaderObjectARB ||  !ext::glCompileShaderARB ||
	!ext::glLinkProgramARB || !ext::glGetInfoLogARB || !ext::glDeleteObjectARB || !ext::glUseProgramObjectARB ||
	!ext::glShaderSourceARB || !ext::glAttachObjectARB || !ext::glGetObjectParameterivARB ||
	!ext::glGetUniformLocationARB || !ext::glUniform4fARB || !ext::glUniform1iARB)
	{
	 MessageBox(NULL, TEXT("Error loading GLSlang shader functions."), TEXT("Error..."), MB_OK);
	 return false;
	}

	// MultiTexturing
	ext::glActiveTextureARB   = (PFNGLACTIVETEXTUREARBPROC)wglGetProcAddress("glActiveTextureARB");
	ext::glMultiTexCoord2fARB = (PFNGLMULTITEXCOORD2FARBPROC)wglGetProcAddress("glMultiTexCoord2fARB");
	ext::glMultiTexCoord3fARB = (PFNGLMULTITEXCOORD3FARBPROC)wglGetProcAddress("glMultiTexCoord3fARB");
    
	// Secondary Color
	ext::glSecondaryColor3fEXT = (PFNGLSECONDARYCOLOR3FEXTPROC)wglGetProcAddress("glSecondaryColor3fEXT");
	ext::glSecondaryColorPointerEXT = (PFNGLSECONDARYCOLORPOINTEREXTPROC)wglGetProcAddress("glSecondaryColorPointerEXT");

	// Blending
	ext::glBlendEquationEXT = (PFNGLBLENDEQUATIONEXTPROC)wglGetProcAddress("glBlendEquationEXT");

	if(strstr(extensions, "WGL_EXT_swap_control") != NULL)
	{
		ext::wglSwapIntervalEXT = (PFNWGLSWAPINTERVALEXTPROC)wglGetProcAddress("wglSwapIntervalEXT");
	}

	//Frame Buffer Objects
	ext::glGenFramebuffersEXT        = (PFNGLGENFRAMEBUFFERSEXTPROC)wglGetProcAddress("glGenFramebuffersEXT");
	ext::glBindFramebufferEXT        = (PFNGLBINDFRAMEBUFFEREXTPROC)wglGetProcAddress("glBindFramebufferEXT");
	ext::glGenRenderbuffersEXT       = (PFNGLGENRENDERBUFFERSEXTPROC)wglGetProcAddress("glGenRenderbuffersEXT");
	ext::glBindRenderbufferEXT       = (PFNGLBINDRENDERBUFFEREXTPROC)wglGetProcAddress("glBindRenderbufferEXT");
	ext::glRenderbufferStorageEXT    = (PFNGLRENDERBUFFERSTORAGEEXTPROC)wglGetProcAddress("glRenderbufferStorageEXT");
	ext::glFramebufferRenderbufferEXT= (PFNGLFRAMEBUFFERRENDERBUFFEREXTPROC)wglGetProcAddress("glFramebufferRenderbufferEXT");
	ext::glFramebufferTexture2DEXT   = (PFNGLFRAMEBUFFERTEXTURE2DEXTPROC)wglGetProcAddress("glFramebufferTexture2DEXT");
	ext::glCheckFramebufferStatusEXT = (PFNGLCHECKFRAMEBUFFERSTATUSEXTPROC)wglGetProcAddress("glCheckFramebufferStatusEXT");
	ext::glDeleteFramebuffersEXT     = (PFNGLDELETEFRAMEBUFFERSEXTPROC)wglGetProcAddress("glDeleteFramebuffersEXT");
	ext::glDeleteRenderbuffersEXT    = (PFNGLDELETERENDERBUFFERSEXTPROC)wglGetProcAddress("glDeleteRenderbuffersEXT");
	ext::glDrawBuffers               = (PFNGLDRAWBUFFERSPROC)wglGetProcAddress("glDrawBuffers");

	return true;
}
