#ifndef _WindowsExtensions_
#define _WindowsExtensions_

#include "glext.h"
#include "wglext.h"

#define DLL_EXPORT
#if defined DLL_EXPORT
#define DECLDIR __declspec(dllexport)
#else
#define DECLDIR __declspec(dllimport)
#endif

class DECLDIR ext
{
public:
	// GLSlang Shaders
	static PFNGLCREATEPROGRAMOBJECTARBPROC     glCreateProgramObjectARB    ;
	static PFNGLCREATESHADEROBJECTARBPROC      glCreateShaderObjectARB     ;
	static PFNGLLINKPROGRAMARBPROC             glLinkProgramARB            ;
	static PFNGLCOMPILESHADERARBPROC           glCompileShaderARB          ;
	static PFNGLGETINFOLOGARBPROC              glGetInfoLogARB             ;
	static PFNGLDELETEOBJECTARBPROC            glDeleteObjectARB           ;
	static PFNGLUSEPROGRAMOBJECTARBPROC        glUseProgramObjectARB       ;
	static PFNGLSHADERSOURCEARBPROC            glShaderSourceARB           ;
	static PFNGLATTACHOBJECTARBPROC            glAttachObjectARB           ;

	// Shaders
	static PFNGLDETACHOBJECTARBPROC            glDetachObjectARB           ;
	static PFNGLGETOBJECTPARAMETERIVARBPROC    glGetObjectParameterivARB   ;
	static PFNGLGETUNIFORMLOCATIONARBPROC      glGetUniformLocationARB     ;
	static PFNGLGETATTRIBLOCATIONARBPROC       glGetAttribLocationARB      ;
	static PFNGLUNIFORM4FARBPROC               glUniform4fARB              ;
	static PFNGLUNIFORM1FARBPROC               glUniform1fARB              ;
	static PFNGLUNIFORM1IARBPROC               glUniform1iARB              ;
	//static PFNGLVERTEXATTRIB3SVARBPROC         glVertexAttrib3svARB        ;
	static PFNGLENABLEVERTEXATTRIBARRAYARBPROC glEnableVertexAttribArrayARB;
	static PFNGLVERTEXATTRIBPOINTERARBPROC     glVertexAttribPointerARB    ;

	// MultiTexturing
	static PFNGLMULTITEXCOORD2FARBPROC         glMultiTexCoord2fARB        ;
	static PFNGLMULTITEXCOORD3FARBPROC         glMultiTexCoord3fARB        ;
	static PFNGLACTIVETEXTUREARBPROC           glActiveTextureARB          ;

	// Secondary Color
	static PFNGLSECONDARYCOLOR3FEXTPROC        glSecondaryColor3fEXT       ;
	static PFNGLSECONDARYCOLORPOINTEREXTPROC   glSecondaryColorPointerEXT  ;

	// Blending
	static PFNGLBLENDEQUATIONEXTPROC           glBlendEquationEXT          ;
	//static PFNGLFUNCSUBTRACTEXT              glFuncSubtractEXT           ;

	// V-Sync
	static PFNWGLSWAPINTERVALEXTPROC           wglSwapIntervalEXT          ;

	// Frame Buffer Objects
	static PFNGLGENFRAMEBUFFERSEXTPROC         glGenFramebuffersEXT        ;
	static PFNGLBINDFRAMEBUFFEREXTPROC         glBindFramebufferEXT        ;
	static PFNGLGENRENDERBUFFERSEXTPROC        glGenRenderbuffersEXT       ;
	static PFNGLBINDRENDERBUFFEREXTPROC        glBindRenderbufferEXT       ;
	static PFNGLRENDERBUFFERSTORAGEEXTPROC     glRenderbufferStorageEXT    ;
	static PFNGLFRAMEBUFFERRENDERBUFFEREXTPROC glFramebufferRenderbufferEXT;
	static PFNGLFRAMEBUFFERTEXTURE2DEXTPROC    glFramebufferTexture2DEXT   ;
	static PFNGLCHECKFRAMEBUFFERSTATUSEXTPROC  glCheckFramebufferStatusEXT ;
	static PFNGLDELETEFRAMEBUFFERSEXTPROC      glDeleteFramebuffersEXT     ;
	static PFNGLDELETERENDERBUFFERSEXTPROC     glDeleteRenderbuffersEXT    ;
	static PFNGLDRAWBUFFERSPROC                glDrawBuffers               ;
};

bool DECLDIR InitExtensions();

#endif