//Brent Cowan - Sept. 19 / 2007

#include "Vector2D.h"
#include "Vector3D.h"

#ifndef _Functions_
#define _Functions_

#define DLL_EXPORT
#if defined DLL_EXPORT
#define DECLDIR __declspec(dllexport)
#else
#define DECLDIR __declspec(dllimport)
#endif

// Convert numbers and such to string data by streaming them.
template <typename T>
std::string DECLDIR ToString(const T& value)
{
	std::stringstream ss; ss << value; 
	return ss.str();
}

//Exponential Smoothing: can be used with floats and Vectors
template<class T>
T DECLDIR Smooth(T current, T newValue, float amount, float seconds)
{
	static float smoothFactor;
	smoothFactor = amount/seconds;
	return (current*smoothFactor+newValue)/(smoothFactor+1.0f);
}

void DECLDIR DrawLine(Vector2D P1, Vector2D P2, float width);

void DECLDIR DrawCircle(Vector2D center, float radius, float width);

Vector2D DECLDIR ClosestPointSeg(Vector2D point1, Vector2D point2, Vector2D center);

bool DECLDIR LineCircleCollision(Vector2D point1, Vector2D point2, Vector2D center, float radius);

float DECLDIR RotateToward(float currentDir, float desiredDir, float rotationSpeed);

bool DECLDIR CircleCircleCollision(Vector2D center1, float radius1, Vector2D center2, float radius2);

float DECLDIR DirectionDifference(float direction1, float direction2);

float DECLDIR DirectionInRange(float direction);

#endif