//Brent Cowan May 22 2010

#include "stdafx.h"
#include "GLFW/IncludesGLFW.h"
#include "Vector2D.h"
#include "JoystickManager.h"

DECLDIR JoystickManager::JoystickManager()
{
	for(int j = 0; j<8; j++)
	{
		for(int i = 0; i<16; i++)
		{
			controller[j].button[i]   = 0;
			controller[j].previous[i] = 0;
		}
		for(int i = 0; i<6; i++)
		{
			controller[j].axis[i] = 0.0f;
		}
	}
}

void DECLDIR JoystickManager::Step()
{
	for(int j = 0; j<8; j++)
	{
		for(int i = 0; i<16; i++)
		{
			controller[j].previous[i] = controller[j].button[i];
		}
		glfwGetJoystickButtons(j, controller[j].button, 16);
		glfwGetJoystickPos(j, controller[j].axis, 6);
	}
}

bool DECLDIR JoystickManager::IsConnected(int joystickNumber)
{
	if(joystickNumber<0 || joystickNumber>7)return false;

	return glfwGetJoystickParam(joystickNumber, GLFW_PRESENT)>0;
}

bool DECLDIR JoystickManager::GetButtonHold(int joystickNumber, int buttonNumber)
{
	if(joystickNumber<0 || joystickNumber>7)return false;
	if(buttonNumber<0 || buttonNumber>15)return false;

	return controller[joystickNumber].button[buttonNumber]>0;
}

bool DECLDIR JoystickManager::GetButtonPress(int joystickNumber, int buttonNumber)
{
	if(joystickNumber<0 || joystickNumber>7)return false;
	if(buttonNumber<0 || buttonNumber>15)return false;

	return (controller[joystickNumber].button[buttonNumber]>0 && !(controller[joystickNumber].previous[buttonNumber]>0));
}

bool DECLDIR JoystickManager::GetButtonRelease(int joystickNumber, int buttonNumber)
{
	if(joystickNumber<0 || joystickNumber>7)return false;
	if(buttonNumber<0 || buttonNumber>15)return false;

	return (!(controller[joystickNumber].button[buttonNumber]>0) && controller[joystickNumber].previous[buttonNumber]>0);
}

float DECLDIR JoystickManager::GetAxis(int joystickNumber, int axisNumber)
{
	if(joystickNumber<0 || joystickNumber>7)return 0.0f;
	if(axisNumber<0 || axisNumber>5)return 0.0f;

	return controller[joystickNumber].axis[axisNumber];
}
