
#ifndef _JoystickManager_
#define _JoystickManager_

#define DLL_EXPORT
#if defined DLL_EXPORT
#define DECLDIR __declspec(dllexport)
#else
#define DECLDIR __declspec(dllimport)
#endif

struct JoystickButtons
{
	unsigned char button[16];
	unsigned char previous[16];
	float         axis[6];
};

class DECLDIR JoystickManager
{
private:
	JoystickButtons controller[8];

public:
	JoystickManager();
	void Step();

	bool  IsConnected(int joystickNumber);
	bool  GetButtonPress(int joystickNumber, int buttonNumber);
	bool  GetButtonHold(int joystickNumber, int buttonNumber);
	bool  GetButtonRelease(int joystickNumber, int buttonNumber);
	float GetAxis(int joystickNumber, int axisNumber);

};

#endif	