//Brent Cowan May 22 2010
#include "stdafx.h"
#include "GLFW/IncludesGLFW.h"
#include "KeyboardManager.h"

DECLDIR KeyboardManager::KeyboardManager()
{	
	//Set regular keys
	for(i=0; i<96; i++)
	{
		keyPrevious[i] = false;
		keyDown[i]     = false;
	}

	//Set special keys
	for(i=0; i<62; i++)
	{
		specialPrevious[i] = false;
		specialDown[i]     = false;
	}

	//Map keyboard keys to their shift versions
	shiftCharacter[0]  = char(34); // ' "
	shiftCharacter[1]  = char(40); // ( (
	shiftCharacter[2]  = char(41); // ) )
	shiftCharacter[3]  = char(42); // * *
	shiftCharacter[4]  = char(43); // + +
	shiftCharacter[5]  = char(60); // , <
	shiftCharacter[6]  = char(95); // - _
	shiftCharacter[7]  = char(62); // . >
	shiftCharacter[8]  = char(63); // / ?
	shiftCharacter[9]  = char(41); // 0 )
	shiftCharacter[10] = char(33); // 1 !
	shiftCharacter[11] = char(64); // 2 @
	shiftCharacter[12] = char(35); // 3 #
	shiftCharacter[13] = char(36); // 4 $
	shiftCharacter[14] = char(37); // 5 %
	shiftCharacter[15] = char(94); // 6 ^
	shiftCharacter[16] = char(38); // 7 &
	shiftCharacter[17] = char(42); // 8 *
	shiftCharacter[18] = char(40); // 9 (
	shiftCharacter[19] = char(58); // : :
	shiftCharacter[20] = char(58); // ; :
	shiftCharacter[21] = char(60); // < <
	shiftCharacter[22] = char(43); // = +
	shiftCharacter[23] = char(62); // > >
	shiftCharacter[24] = char(63); // ? ?
	shiftCharacter[25] = char(64); // @ @
	shiftCharacter[26] = char(65); // A A
	shiftCharacter[27] = char(66); // B B
	shiftCharacter[28] = char(67); // C C
	shiftCharacter[29] = char(68); // D D
	shiftCharacter[30] = char(69); // E E
	shiftCharacter[31] = char(70); // F F
	shiftCharacter[32] = char(71); // G G
	shiftCharacter[33] = char(72); // H H
	shiftCharacter[34] = char(73); // I I
	shiftCharacter[35] = char(74); // J J
	shiftCharacter[36] = char(75); // K K
	shiftCharacter[37] = char(76); // L L
	shiftCharacter[38] = char(77); // M M
	shiftCharacter[39] = char(78); // N N
	shiftCharacter[40] = char(79); // O O
	shiftCharacter[41] = char(80); // P P
	shiftCharacter[42] = char(81); // Q Q
	shiftCharacter[43] = char(82); // R R
	shiftCharacter[44] = char(83); // S S
	shiftCharacter[45] = char(84); // T T
	shiftCharacter[46] = char(85); // U U
	shiftCharacter[47] = char(86); // V V
	shiftCharacter[48] = char(87); // W W
	shiftCharacter[49] = char(88); // X X
	shiftCharacter[50] = char(89); // Y Y
	shiftCharacter[51] = char(90); // Z Z
	shiftCharacter[52] = char(123);// [ {
	shiftCharacter[53] = char(124);// \ |
	shiftCharacter[54] = char(125);// ] }
	shiftCharacter[55] = char(94); // ^ ^
	shiftCharacter[56] = char(95); // _ _
	shiftCharacter[57] = char(126);// ` ~
	shiftCharacter[58] = char(65); // a A
	shiftCharacter[59] = char(66); // b B
	shiftCharacter[60] = char(67); // c C
	shiftCharacter[61] = char(68); // d D
	shiftCharacter[62] = char(69); // e E
	shiftCharacter[63] = char(70); // f F
	shiftCharacter[64] = char(71); // g G
	shiftCharacter[65] = char(72); // h H
	shiftCharacter[66] = char(73); // i I
	shiftCharacter[67] = char(74); // j J
	shiftCharacter[68] = char(75); // k K
	shiftCharacter[69] = char(76); // l L
	shiftCharacter[70] = char(77); // m M
	shiftCharacter[71] = char(78); // n N
	shiftCharacter[72] = char(79); // o O
	shiftCharacter[73] = char(80); // p P
	shiftCharacter[74] = char(81); // q Q
	shiftCharacter[75] = char(82); // r R
	shiftCharacter[76] = char(83); // s S
	shiftCharacter[77] = char(84); // t T
	shiftCharacter[78] = char(85); // u U
	shiftCharacter[79] = char(86); // v V
	shiftCharacter[80] = char(87); // w W
	shiftCharacter[81] = char(88); // x X
	shiftCharacter[82] = char(89); // y Y
	shiftCharacter[83] = char(90); // z Z
}

void DECLDIR KeyboardManager::Step()
{
	//Update regular keys
	for(i=32; i<127; i++)
	{
		keyPrevious[i-32] = keyDown[i-32];
		keyDown[i-32]     = glfwGetKey(i)>0;
	}

	//Update special keys
	for(i=257; i<319; i++)
	{
		specialPrevious[i-257] = specialDown[i-257];
		specialDown[i-257]     = glfwGetKey(i)>0;
	}
}

bool DECLDIR KeyboardManager::GetKeyHold(int key)
{	
	if(key>31 && key<127)
	{
		return keyDown[key-32];
	}
	else if(key>256 && key<319)
	{
		return specialDown[key-257];
	}
	else
	{
		return false;
	}
}

bool DECLDIR KeyboardManager::GetKeyRelease(int key)
{	
	if(key>31 && key<127)
	{
		return (!keyDown[key-32] && keyPrevious[key-32]);
	}
	else if(key>256 && key<319)
	{
		return (!specialDown[key-257] && specialPrevious[key-257]);
	}
	else
	{
		return false;
	}
}

bool DECLDIR KeyboardManager::GetKeyPress(int key)
{	
	if(key>31 && key<127)
	{
		return (keyDown[key-32] && !keyPrevious[key-32]);
	}
	else if(key>256 && key<319)
	{
		return (specialDown[key-257] && !specialPrevious[key-257]);
	}
	else
	{
		return false;
	}
}

int DECLDIR KeyboardManager::CorrectCase(int character)
{
	if(character>38 && character<123)
	{
		if(specialDown[GLFW_KEY_LSHIFT-257] || specialDown[GLFW_KEY_RSHIFT-257])
		{
			return int(shiftCharacter[tolower(character)-39]);
		}
		else
		{
			return tolower(character);
		}
	}
	
	return character;
}