//Brent Cowan - May. 19 / 2008

#include "EngineCore.h"
#include "Texture.h"       //abstract class for all types of textures
#include "Image.h"         //Image loading provided by DevIL
#include "ShaderClass.h"
#include "Materials.h"

GLushort MaterialClass::materials = 0;
GLushort MaterialClass::current = 0;

MaterialClass::MaterialClass()
{
	Shader     = NULL;
	Texture[0] = NULL;
	Texture[1] = NULL;
	Texture[2] = NULL;
	textures   = 0;

	materials++;
	ID = materials;	
}

void MaterialClass::Activate()
{
	if(ID!=current)
	{

		Properties.Activate();
		if(Shader!=NULL)
		{
			Shader->Activate();
		}
		else
		{
			ext::glUseProgramObjectARB(0);
		}

		if(textures>0)
		{
			glEnable(GL_TEXTURE);
			ext::glActiveTextureARB(GL_TEXTURE0_ARB); glEnable(GL_TEXTURE_2D);
			glEnable(GL_TEXTURE0_ARB);
			//glTexEnvf(GL_TEXTURE_FILTER_CONTROL, GL_TEXTURE_LOD_BIAS, -0.5f);
			Texture[0]->Activate();
		}
		else
		{
			ext::glActiveTextureARB(GL_TEXTURE0_ARB); glDisable(GL_TEXTURE_2D);
			ext::glActiveTextureARB(GL_TEXTURE1_ARB); glDisable(GL_TEXTURE_2D);
			ext::glActiveTextureARB(GL_TEXTURE2_ARB); glDisable(GL_TEXTURE_2D);
			glDisable(GL_TEXTURE);
		}

		if(textures==1)
		{
			ext::glActiveTextureARB(GL_TEXTURE1_ARB); glDisable(GL_TEXTURE_2D);
			ext::glActiveTextureARB(GL_TEXTURE2_ARB); glDisable(GL_TEXTURE_2D);
		}
		else if(textures==2)
		{
			
			ext::glActiveTextureARB(GL_TEXTURE1_ARB);
			glEnable(GL_TEXTURE_2D);
			glEnable(GL_TEXTURE1_ARB);
			//glTexEnvf(GL_TEXTURE_FILTER_CONTROL, GL_TEXTURE_LOD_BIAS, -0.5f);
			Texture[1]->Activate();
			
			ext::glActiveTextureARB(GL_TEXTURE2_ARB); glDisable(GL_TEXTURE_2D);
		}
		else if(textures==3)
		{
			ext::glActiveTextureARB(GL_TEXTURE1_ARB);
			Texture[1]->Activate();

			ext::glActiveTextureARB(GL_TEXTURE2_ARB);
			//glTexEnvf(GL_TEXTURE_FILTER_CONTROL, GL_TEXTURE_LOD_BIAS, -0.5f);
			Texture[2]->Activate();
		}

		current = ID;
	}
}

void MaterialClass::Deactivate()
{
	glDisable(GL_TEXTURE);
	ext::glUseProgramObjectARB(0);
	current = 0;

	ext::glActiveTextureARB(GL_TEXTURE0_ARB); glDisable(GL_TEXTURE_2D);
	ext::glActiveTextureARB(GL_TEXTURE1_ARB); glDisable(GL_TEXTURE_2D);
	ext::glActiveTextureARB(GL_TEXTURE2_ARB); glDisable(GL_TEXTURE_2D);
	glDisable(GL_TEXTURE);
}
