
#ifndef _MouseManager_
#define _MouseManager_

#define DLL_EXPORT
#if defined DLL_EXPORT
#define DECLDIR __declspec(dllexport)
#else
#define DECLDIR __declspec(dllimport)
#endif

class DECLDIR MouseManager
{
private:
	Vector2D position;
	Vector2D smoothPosition;
	Vector2D lastPosition;
	Vector2D velocity;
	int xPos, yPos;
	bool leftButton, rightButton, leftPrevious, rightPrevious;
	bool middleButton;
	bool middlePrevious;

public:
	MouseManager();
	void Step();

	void SetVisibility(bool show);
	void SetPosition(Vector2D position);
	void SetPosition(float x, float y);

	Vector2D GetPosition();
	Vector2D GetVelocity();
	float GetWheelPosition();
	bool GetLeftPress();
	bool GetRightPress();
	bool GetMiddlePress();
	bool GetLeftHold();
	bool GetRightHold();
	bool GetMiddleHold();
	bool GetLeftRelease();
	bool GetRightRelease();
	bool GetMiddleRelease();
};

#endif	