//Brent Cowan - May. 19 / 2008

#include "GLFW/IncludesGLFW.h"
#include "Extensions.h"
#include "Properties.h"

MaterialProperties::MaterialProperties()
{
	Diffuse[0] =1.0f; Diffuse[1] =1.0f; Diffuse[2] =1.0f; Diffuse[3] =1.0f; 
	Specular[0]=1.0f; Specular[1]=1.0f; Specular[2]=1.0f; Specular[3]=1.0f; 
	Emission[0]=0.0f; Emission[1]=0.0f; Emission[2]=0.0f; Emission[3]=1.0f; 

	Shininess        = 0.0f;
	RenderMode       = 0;
	ThresholdAmount  = 0.5f;
}

void MaterialProperties::Activate()
{
	glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE, Diffuse);
	glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, Specular);
	glMaterialfv(GL_FRONT_AND_BACK, GL_EMISSION, Emission);
	glMaterialf(GL_FRONT_AND_BACK, GL_SHININESS, Shininess*128.0f);

	//Transparency Mode
	if(RenderMode == 0)      //Opaque  no transparency
	{
		glDisable(GL_ALPHA_TEST);
		glDisable(GL_BLEND);
	}
	else if(RenderMode == 1) //Threshold  all or nothing transparency
	{
		glEnable(GL_ALPHA_TEST);
		glAlphaFunc(GL_GREATER, ThresholdAmount);
		glDisable(GL_BLEND);
	}
	else if(RenderMode == 2) //Blend  Normally
	{
		glDisable(GL_ALPHA_TEST);
		glEnable(GL_BLEND);
		glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
		ext::glBlendEquationEXT(GL_FUNC_ADD);
	}
	else if(RenderMode == 3)       //Blend - Additively
	{
		glDisable(GL_ALPHA_TEST);
		glEnable(GL_BLEND);
		glBlendFunc(GL_SRC_ALPHA, GL_ONE);
		ext::glBlendEquationEXT(GL_FUNC_ADD);
	}
	else if(RenderMode == 4)       //Blend - Subtractive
	{
		glDisable(GL_ALPHA_TEST);
		glEnable(GL_BLEND);
		glBlendFunc(GL_SRC_ALPHA, GL_ONE);
		ext::glBlendEquationEXT(GL_FUNC_REVERSE_SUBTRACT);//GL_FUNC_REVERSE_SUBTRACT
	}
	else      //Out of range! defualt to Opaque  no transparency
	{
		glDisable(GL_ALPHA_TEST);
		glDisable(GL_BLEND);
	}
}