
#ifndef _RenderingManager_
#define _RenderingManager_

#define DLL_EXPORT
#if defined DLL_EXPORT
#define DECLDIR __declspec(dllexport)
#else
#define DECLDIR __declspec(dllimport)
#endif

class DECLDIR RenderingManager
{
private:
	bool init;
	float fieldOfView;        // field of view while in perspective mode
	WindowManager* window;
	TimeManager* timer;
	KeyboardManager* keyboard;
	MouseManager* mouse;
	JoystickManager* joystick;
	Color4f clearColor;
	float nearClip;
	float farClip;

public:
	RenderingManager();
	void Init(WindowManager* window, TimeManager* timer, KeyboardManager* keyboard, MouseManager* mouse, JoystickManager* joystick);
	void BeginFrame();
	void EndFrame();
	void Render2D();
	void Render3D();

	void SetFieldOfView(float fieldOfView);
	void SetNearClippingPlane(float nearClippingPlane);
	void SetFarClippingPlane(float farClippingPlane);

	ViewFrustum frustum;
};

#endif	