//Brent Cowan    100233480

#include "GLFW/IncludesGLFW.h"
#include "Extensions.h"
#include "Vector3D.h"
#include "Texture.h"
#include "Image.h"
#include "SkyBox.h"

void SkyBox::Init(char* top, char* bottom, char* front, char* back, char* left, char* right, bool RenderBottom)
{
	renderB = RenderBottom;

	//load in the textures and clamp them so that there's no seam
	T1.Clamp(); 
	T1.Load(top);
	if(renderB)
	{
		T2.Clamp(); //don't need the bottom of the box
		T2.Load(bottom);
	}
	T3.Clamp(); 
	T3.Load(front);
	T4.Clamp(); 
	T4.Load(back);
	T5.Clamp(); 
	T5.Load(right);
	T6.Clamp(); 
	T6.Load(left);
	_size = 300.0f;
}

void SkyBox::Render(Vector3D cameraPos)
{
	glPushMatrix();

	// Move the skybox so that it's centered on the camera.
	glTranslatef(cameraPos.x, cameraPos.y, cameraPos.z);
	

	glPushAttrib(GL_FOG_BIT | GL_DEPTH_BUFFER_BIT | GL_LIGHTING_BIT);
	//glDisable(GL_DEPTH_TEST);
	glDisable(GL_CULL_FACE);

	glEnable(GL_TEXTURE);
	ext::glActiveTextureARB(GL_TEXTURE0_ARB); glEnable(GL_TEXTURE_2D);
	glEnable(GL_TEXTURE0_ARB);
	ext::glActiveTextureARB(GL_TEXTURE1_ARB); glDisable(GL_TEXTURE_2D);
	ext::glActiveTextureARB(GL_TEXTURE2_ARB); glDisable(GL_TEXTURE_2D);
	ext::glActiveTextureARB(GL_TEXTURE0_ARB);

	glDisable(GL_DEPTH_FUNC);
	//glDisable(GL_DEPTH_TEST);
	glDisable(GL_LIGHTING);
	glDisable(GL_FOG);

	// Bottom
	if(renderB)
	{
	T2.Activate();
	glBegin(GL_QUADS);
		glTexCoord2f(1.0f, 1.0f); glVertex3f(-_size, -_size, -_size);
		glTexCoord2f(0.0f, 1.0f); glVertex3f(_size, -_size, -_size);
		glTexCoord2f(0.0f, 0.0f); glVertex3f(_size, -_size, _size);
		glTexCoord2f(1.0f, 0.0f); glVertex3f(-_size, -_size, _size);
	glEnd();
	}
	
	//Top
	T1.Activate();
	glBegin(GL_QUADS);
		glTexCoord2f(1.0f, 1.0f); glVertex3f(-_size, _size, _size);
		glTexCoord2f(0.0f, 1.0f); glVertex3f(_size, _size, _size);
		glTexCoord2f(0.0f, 0.0f); glVertex3f(_size, _size, -_size);
		glTexCoord2f(1.0f, 0.0f); glVertex3f(-_size, _size, -_size);
	glEnd();

	// Front
	T3.Activate();
	glBegin(GL_QUADS);
	glTexCoord2f(0.0f, 0.0f); glVertex3f(-_size, _size, -_size);
	glTexCoord2f(1.0f, 0.0f); glVertex3f(_size, _size, -_size);
	glTexCoord2f(1.0f, 1.0f); glVertex3f(_size, -_size, -_size);
	glTexCoord2f(0.0f, 1.0f); glVertex3f(-_size, -_size, -_size);
	glEnd();

	// Back
	T4.Activate();
	glBegin(GL_QUADS);
		glTexCoord2f(0.0f, 0.0f); glVertex3f(_size, _size, _size);
		glTexCoord2f(1.0f, 0.0f); glVertex3f(-_size, _size, _size);
		glTexCoord2f(1.0f, 1.0f); glVertex3f(-_size, -_size, _size);
		glTexCoord2f(0.0f, 1.0f); glVertex3f(_size, -_size, _size);
	glEnd();

	// Right
	T5.Activate();
	glBegin(GL_QUADS);
		glTexCoord2f(1.0f, 0.0f); glVertex3f(_size, _size, _size);
		glTexCoord2f(1.0f, 1.0f); glVertex3f(_size, -_size, _size);
		glTexCoord2f(0.0f, 1.0f); glVertex3f(_size, -_size, -_size);
		glTexCoord2f(0.0f, 0.0f); glVertex3f(_size, _size, -_size);
	glEnd();

	// Left
	T6.Activate();
	glBegin(GL_QUADS);
		glTexCoord2f(1.0f, 0.0f); glVertex3f(-_size, _size, -_size);
		glTexCoord2f(1.0f, 1.0f); glVertex3f(-_size, -_size, -_size); 
		glTexCoord2f(0.0f, 1.0f); glVertex3f(-_size, -_size, _size);
		glTexCoord2f(0.0f, 0.0f); glVertex3f(-_size, _size, _size);
	glEnd();

	glEnable(GL_DEPTH_FUNC);
	//glEnable(GL_DEPTH_TEST);
	glEnable(GL_LIGHTING);
	glEnable(GL_FOG);
	glEnable(GL_CULL_FACE);

	glPopAttrib();
	glEndList();
	glPopMatrix();
}