//Brent Cowan    100233480

//this class draws a picture on the screen in 2D.
//Any scale, rotation, location, and it tiles too

#include <math.h>
#include "GLFW/IncludesGLFW.h"
#include "Extensions.h"
#include "Vector2D.h"
#include "Sprite.h"

Sprite::Sprite(float width, float height)
{
	this->width  = width; 
	this->height = height;
	x = 0.0f; y = 0.0f; 
	depth = 1.0f; 
	rotation = 0.0f;
	originX = width/2.0f; originY = height/2.0f;
	u1 = 0.0f; v1 = 0.0f;
	u2 = 1.0f; v2 = 1.0f;
}

Sprite::Sprite()
{
	width = 100.0f; height = 100.0f;
	x = 0.0f; y = 0.0f; 
	depth = 1.0f; 
	rotation = 0.0f;
	originX = 0.0f; originY = 0.0f;
	u1 = 0.0f; v1 = 0.0f;
	u2 = 1.0f; v2 = 1.0f;
}

void Sprite::Render()
{
	glPushMatrix();

	glTranslatef(x, y, -depth);
	glRotatef(rotation, 0.0f, 0.0f, 1.0f);
	glTranslatef(-originX, -originY, 0.0f);
	

	glBegin(GL_QUADS);
		ext::glMultiTexCoord2fARB(GL_TEXTURE0_ARB, u1, v1);
		glVertex3f(0.0f, 0.0f, 0.0f);
		
		ext::glMultiTexCoord2fARB(GL_TEXTURE0_ARB, u2, v1);
		glVertex3f(width, 0.0f, 0.0f);

		ext::glMultiTexCoord2fARB(GL_TEXTURE0_ARB, u2, v2);
		glVertex3f(width, height, 0.0f);

		ext::glMultiTexCoord2fARB(GL_TEXTURE0_ARB, u1, v2);
		glVertex3f(0.0f, height, 0.0f);	
	glEnd();

	glPopMatrix();
}

bool Sprite::PointOnSprite(Vector2D point)
{
	point.x = point.x - x;
	point.y = point.y - y;
	point.Rotate(-rotation);
	point.x = point.x + originX;
	point.y = point.y + originY;

	if(point.x<0.0f || point.x>width)return false;

	if(point.y<0.0f || point.y>height)return false;

	return true;
}

Vector2D Sprite::GetUV(Vector2D point)
{
	point.x = point.x - x;
	point.y = point.y - y;
	point.Rotate(-rotation);
	point.x = point.x + originX;
	point.y = point.y + originY;

	if(point.x<0.0f || point.x>width)return Vector2D(-1.0f, -1.0f);

	if(point.y<0.0f || point.y>height)return Vector2D(-1.0f, -1.0f);

	float gainU, gainV;
	gainU = point.x/width;
	gainV = 1.0f-point.y/height;
	gainU = gainU*u2 + (1.0f-gainU)*u1;
	gainV = gainV*v2 + (1.0f-gainV)*v1;

	return Vector2D(gainU, gainV);
}
