// Brent Cowan Jan. 25 / 2007
// Calculate FPS and elapsed time
#include "stdafx.h"
#include "Mmsystem.h"
#include "TimeManager.h"
#include <windows.h>

DECLDIR TimeManager::TimeManager()
{
	flag = false; //set this to true after fist run
	frame = 0;    //track number of frames
	fpsTime = 0.0;//stores frames per second
	lastTime = timeGetTime();//set last time to clock
	FPS_INTERVAL = 1.0f;
	elapsedTime = 0.001f; //start off > 0 to prevent possible division by 0
	SmoothElapsedTime = 0.001f;//smoothed version
	FPS = 60.0f;
}

void DECLDIR TimeManager::Step()
{
	thisTime = timeGetTime();//get time from clock

	//if this is the first run through,set lastTime to the current time
	if(!flag){flag = true; lastTime = thisTime;}

	//calculate the elapsed time
	elapsedTime = (float)(thisTime - lastTime)/1000.0f;
	fpsTime += elapsedTime;
	if (fpsTime > FPS_INTERVAL)
	{
		FPS = float(frame)/fpsTime;
		frame = 0;
		fpsTime -= FPS_INTERVAL;
	}
	lastTime = thisTime;

	//Prevent low frame rates from causing collision errors
	if(elapsedTime > 0.05f)elapsedTime = 0.05f;

	//Now smooth the time
	SmoothElapsedTime = (SmoothElapsedTime*3.0f+elapsedTime)/4.0f;

	frame++;
}

float DECLDIR TimeManager::GetElapsedTime()
{
	return SmoothElapsedTime;
}

float DECLDIR TimeManager::GetFramesPerSecond()
{
	return FPS;
}