#ifndef _VECTOR_2D_
#define _VECTOR_2D_

#define DLL_EXPORT
#if defined DLL_EXPORT
#define DECLDIR __declspec(dllexport)
#else
#define DECLDIR __declspec(dllimport)
#endif

class DECLDIR Vector2D
{
private:
	static float DTR;
	static float RTD;
public:
	Vector2D();
	Vector2D(float X, float Y);
	Vector2D(const Vector2D &v);

	bool operator==(const Vector2D &v);
	void operator=(const Vector2D &v);
	void operator+=(const Vector2D &v);
	void operator-=(const Vector2D &v);
	void operator/=(const Vector2D &v);
	void operator*=(const Vector2D &v);
	Vector2D operator+(const Vector2D &v2);
	Vector2D operator-(const Vector2D &v2);      
	Vector2D operator/(const Vector2D &v2);
	Vector2D operator*(const Vector2D &v2);
	Vector2D operator/(float f);
	Vector2D operator*(float f);

	void  Rotate(float angle);
	float Dot(const Vector2D &v);
	float GetLength();
	void  Normalize();
	Vector2D AngleToVector(float angle);
	float VectorToAngle(const Vector2D &v);
	Vector2D Perp();
	float GetLengthSq();
	void Reflect(Vector2D& norm);
	void SetLength(float length);

	float x, y;
};

#endif